function SummariseMaths(m)
{
  EnsureServicesReady();
  var mis = Components.classes["@cellml.org/tools/pcenv/mathmlInputServices;1"].
    getService(Components.interfaces.IMathMLInputServices);
  var r = "=== Summary of Equations ===\n";
  var cci = m.allComponents.iterateComponents();
  var cc;
  while ((cc = cci.nextComponent()) != null)
  {
    r += "==== Component " + cc.name + " ====\n";
    var mi = cc.QueryInterface(Components.interfaces.cellml_apiIMathContainer).math.iterate();
    var mat;
    while ((mat = mi.next()) != null)
    {
      mat = mat.QueryInterface(Components.interfaces.mathml_domIMathMLContainer);
      var i = 1;
      var ma;
      while ((ma = mat.getArgument(i)) != null)
      {
        i = i + 1;
        var output1;
        output1 = mis.mathMLToInputFormat(ma);
        var el = mis.inputFormatToMathML(ma.ownerDocument, output1);
        if (el.namespaceURI == "http://www.cellml.org/tools/mathml-input/error#")
        {
          prompt("Value", el.getAttribute("problem") + " col " +
                el.getAttribute("column") + " in " + output1);
        }
        else
        {
          r += window.context.cellmlBootstrap.serialiseNode(el);
          var output2 = "Valid: " + mis.mathMLToInputFormat(el) + "\n";
          r += output2;
        }
      }
    }
  }
  return r;
}

function DoMathSummary()
{
  var s = document.getElementById("mathsummary");
  var m = window.arguments[0];
  s.value = SummariseMaths(m);
}
