function DialogCreated()
{
  Status("New model dialog created.");
}

function DialogAccepted()
{
  var c = GetContext();
  var modelname = document.getElementById("modelname").value;
  if (modelname == "")
  {
    Status("You need to enter a model name.");
    document.getElementById("errorbox").style.visibility = "visible";
    document.getElementById("errorlabel").value = "Please enter a model name";
    return false;
  }
  var version = document.getElementById("version").value;
  Status("Creating new model " + modelname + "(CellML version " + version +
         ")...");
  var m = c.cellmlBootstrap.createModel(version);
  Status("Model constructed, registering with your CellML Context...");
  var lm = c.loadedModels;
  var n = lm.makeNode(m);
  n.name = modelname;
  n.stampModifiedNow();
  lm.addModel(n);
  Status("Model " + modelname + " (CellML version " + version +
         ") created.");
  return true;
}

function DialogCancelled()
{
}

function DialogHelp()
{
  open("chrome://pcenv/content/help/manual.html#new");
}
