function setLabel(lab, txt)
{
  var cn = lab.childNodes;
  while (cn.length)
    lab.removeChild(cn[0]);
  if (txt != null)
  {
    var tn = lab.ownerDocument.createTextNode(txt);
    lab.appendChild(tn);
  }
}

function CompareObjects(obj1, obj2)
{
  try
  {
    if (obj1 == obj2)
      return true;
    obj1 = obj1.QueryInterface(Components.interfaces.IWrappedPCM);
    obj2 = obj2.QueryInterface(Components.interfaces.IWrappedPCM);
    if (!obj1 || !obj2)
      return false;
    return obj1.objid == obj2.objid;
  }
  catch (e)
  {
    return false;
  }
}

function Objid(obj)
{
  return obj.QueryInterface(Components.interfaces.IWrappedPCM).objid;
}

function randomCmeta()
{
  var alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
  var allvalid = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-" +
        "_{}[]/?;:~`!@$^*()+=|\\";
  var l = 10, i;
  var s = alphabet[parseInt(Math.random() * alphabet.length)];
  for (i = 0; i < l; i++)
    s = s + allvalid[parseInt(Math.random() * allvalid.length)];
  return s;
}
