function UserTag()
{
  this.wrappedJSObject = this;
}

UserTag.prototype =
{
  QueryInterface: function(IID)
  {
    if (IID == Components.interfaces.nsISupports ||
        IID == Components.interfaces.cellml_apiIUserData)
      return this;
    throw Components.results.NS_ERROR_NO_INTERFACE;
  }
};

function IsTagged(imp, name)
{
  try
  {
    imp.getUserData("http://www.cellml.org/tools/pcenv/#" + name);
    return true;
  }
  catch (e)
  {
    return false;
  }
}

function GetTag(imp, name)
{
  try
  {
    return imp.getUserData("http://www.cellml.org/tools/pcenv/#" + name).
      wrappedJSObject;
  }
  catch (e)
  {
    return null;
  }
}

function TagWithName(imp, name)
{
  var ut;
  imp.setUserData("http://www.cellml.org/tools/pcenv/#" + name,
                  (ut = new UserTag()));
  return ut;
}

function UntagWithName(imp, name)
{
  if (imp == null)
    return;
  var t = GetTag(imp, name);
  for (i in t)
    delete t[i];
  imp.setUserData("http://www.cellml.org/tools/pcenv/#" + name,
                  null);
}
